#include <stdlib.h>
#include "Scene.h"


Scene::Scene()
{
   textureCount = 0;
   head_ptr = NULL;
   tail_ptr = NULL;
}


Scene::~Scene()
{
   destroyList();
}


void Scene::addTexture( Texture *tex)
{
   textures[textureCount++] = tex;
   return;
}


void Scene::addTriangle( Triangle *tri )
{
   if (head_ptr == NULL) /* insert the first Triangle into an empty list */
   {
      head_ptr = new TriangleListNode();
      head_ptr->t = tri;
      tail_ptr = head_ptr;
   }
   else
   {
      tail_ptr->next = new TriangleListNode();
      tail_ptr = tail_ptr->next;
      tail_ptr->t = tri;
   }
   return;
}


/* set the perspective projection matrix given the following values */
void Scene::setProjectionMatrix(float eye_fov, float aspect_ratio, float near, float far)
{
   /* Not done yet */
}


/* set the modelview matrix with the given parameters */
void Scene::setViewMatrix(float *eye_pos, float eye_theta, float eye_phi)
{
   /* Not done yet */
}

void Scene::setModelMatrix(  )
{
   /* Not done yet */
}


void Scene::destroyList()
{
   TriangleListNode *ptr;

   while (head_ptr)
   {
      ptr = head_ptr->next;

      free(head_ptr->t); /* free the Triangle object */
      free(head_ptr);    /* free the TriangleListNode object */

      head_ptr = ptr;
   }
   head_ptr = NULL;
   tail_ptr = NULL;
   return;
}
