#include <stdio.h>
#include "Vertex.h"

Vertex::Vertex()
{
   set(0, 0, 0);
}

Vertex::Vertex(float _x, float _y, float _z)
{
   set(_x, _y, _z);
}

Vertex::Vertex(float _x, float _y, float _z, float _w)
{
   x = _x;     y = _y;     z = _z;     w = _w;
}

void Vertex::set(float _x, float _y, float _z)
{
   x = _x;     y = _y;     z = _z;     w = 1;
}

/* for debugging */
void Vertex::print(void)
{
   fprintf(stderr,"[%f %f %f %f]\n", x, y, z, w);
}
